import _ladifireStylex from "@ladifire/stylex";
import _ladifireUiReactIcons from "@ladifire-ui-react/icons";
import _reactUiStatelyToggle from "@react-ui-stately/toggle";
import _ladifireUiReactProvider from "@ladifire-ui-react/provider";
import _reactUiAriaInteractions from "@react-ui-aria/interactions";
import _reactAriaCheckbox from "@react-aria/checkbox";
import _reactUiAriaFocus from "@react-ui-aria/focus";
import _ladifireUiReactUtils from "@ladifire-ui-react/utils";
import _react from "react";
import _babelRuntimeHelpersEsmObjectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import _babelRuntimeHelpersEsmExtends from "@babel/runtime/helpers/esm/extends";
import _babelRuntimeHelpersInteropRequireDefault from "@babel/runtime/helpers/interopRequireDefault";
import _babelRuntimeHelpersInteropRequireWildcard from "@babel/runtime/helpers/interopRequireWildcard";
// ASSET: /home/cong/Github/ladifire/ladifire-ui-react/packages/@ladifire-ui-react/checkbox/src/index.ts
var $a2c394180a52761b9ab5c8ddb88da4b8$exports = {};
Object.defineProperty($a2c394180a52761b9ab5c8ddb88da4b8$exports, "__esModule", {
  value: true
});
// ASSET: /home/cong/Github/ladifire/ladifire-ui-react/packages/@ladifire-ui-react/checkbox/src/Checkbox.tsx
var $ad86caa2b7c07dadd21ed122a0b52380$exports = {};
var $ad86caa2b7c07dadd21ed122a0b52380$var$_interopRequireWildcard = _babelRuntimeHelpersInteropRequireWildcard;
var $ad86caa2b7c07dadd21ed122a0b52380$var$_interopRequireDefault = _babelRuntimeHelpersInteropRequireDefault;
Object.defineProperty($ad86caa2b7c07dadd21ed122a0b52380$exports, "__esModule", {
  value: true
});
var $ad86caa2b7c07dadd21ed122a0b52380$export$Checkbox = void 0;
$ad86caa2b7c07dadd21ed122a0b52380$exports.Checkbox = $ad86caa2b7c07dadd21ed122a0b52380$export$Checkbox;
var $ad86caa2b7c07dadd21ed122a0b52380$var$_extends2 = $ad86caa2b7c07dadd21ed122a0b52380$var$_interopRequireDefault(_babelRuntimeHelpersEsmExtends);
var $ad86caa2b7c07dadd21ed122a0b52380$var$_objectWithoutPropertiesLoose2 = $ad86caa2b7c07dadd21ed122a0b52380$var$_interopRequireDefault(_babelRuntimeHelpersEsmObjectWithoutPropertiesLoose);
var $ad86caa2b7c07dadd21ed122a0b52380$var$React = $ad86caa2b7c07dadd21ed122a0b52380$var$_interopRequireWildcard(_react);
var $ad86caa2b7c07dadd21ed122a0b52380$var$_utils = _ladifireUiReactUtils;
var $ad86caa2b7c07dadd21ed122a0b52380$var$_focus = _reactUiAriaFocus;
var $ad86caa2b7c07dadd21ed122a0b52380$var$_checkbox = _reactAriaCheckbox;
var $ad86caa2b7c07dadd21ed122a0b52380$var$_interactions = _reactUiAriaInteractions;
var $ad86caa2b7c07dadd21ed122a0b52380$var$_provider = _ladifireUiReactProvider;
var $ad86caa2b7c07dadd21ed122a0b52380$var$_toggle = _reactUiStatelyToggle;
var $ad86caa2b7c07dadd21ed122a0b52380$var$_icons = _ladifireUiReactIcons;
var $ad86caa2b7c07dadd21ed122a0b52380$var$_stylex = $ad86caa2b7c07dadd21ed122a0b52380$var$_interopRequireWildcard(_ladifireStylex);

/*
 * Copyright 2020 Ladifire. All rights reserved.
 * This file is licensed to you under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License. You may obtain a copy
 * of the License at http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under
 * the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR REPRESENTATIONS
 * OF ANY KIND, either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
const $ad86caa2b7c07dadd21ed122a0b52380$var$styles = $ad86caa2b7c07dadd21ed122a0b52380$var$_stylex.default.create({
  dash: {
    marginLeft: 1
  },
  label: {
    display: 'inline-flex',
    boxSizing: 'border-box',
    alignItems: 'flex-start',
    position: 'relative',
    verticalAlign: 'top',
    maxWidth: '100%',
    isolation: 'isolate'
  },
  checkbox: {
    '::before': {
      position: 'absolute',
      content: '""',
      zIndex: 0,
      boxSizing: 'border-box',
      width: 18,
      height: 18,
      borderRadius: 4,
      borderWidth: 2,
      borderStyle: 'solid',
      borderColor: 'var(--always-gray-75)',
      transition: 'border 100ms ease-in-out, box-shadow 100ms ease-in-out'
    },
    '::after': {
      position: 'absolute',
      content: '""',
      display: 'block',
      boxSizing: 'border-box',
      borderRadius: 1,
      left: 0,
      right: 0,
      bottom: 0,
      top: 0,
      margin: 2,
      transform: 'translateX(0)',
      transition: 'opacity 100ms ease-out, margin 100ms ease-out'
    }
  },
  checkboxChecked: {
    '::before': {
      borderWidth: 9,
      borderColor: 'var(--accent)'
    },
    '::after': {
      a: 1,
      color: 'red'
    }
  }
});

function $ad86caa2b7c07dadd21ed122a0b52380$var$Checkbox(props, ref) {
  props = (0, $ad86caa2b7c07dadd21ed122a0b52380$var$_provider.useProviderProps)(props);
  let {
    isIndeterminate = false,
    isEmphasized = false,
    isDisabled = false,
    autoFocus,
    children,
    disabledHoverBackground = false
  } = props,
      otherProps = (0, $ad86caa2b7c07dadd21ed122a0b52380$var$_objectWithoutPropertiesLoose2.default)(props, ["isIndeterminate", "isEmphasized", "isDisabled", "autoFocus", "children", "disabledHoverBackground"]);
  let {
    styleProps
  } = (0, $ad86caa2b7c07dadd21ed122a0b52380$var$_utils.useStyleProps)(otherProps);
  let {
    hoverProps,
    isHovered
  } = (0, $ad86caa2b7c07dadd21ed122a0b52380$var$_interactions.useHover)(props);
  let inputRef = $ad86caa2b7c07dadd21ed122a0b52380$var$React.useRef(null);
  let domRef = (0, $ad86caa2b7c07dadd21ed122a0b52380$var$_utils.useFocusableRef)(ref, inputRef);
  let state = (0, $ad86caa2b7c07dadd21ed122a0b52380$var$_toggle.useToggleState)(props);
  let {
    inputProps
  } = (0, $ad86caa2b7c07dadd21ed122a0b52380$var$_checkbox.useCheckbox)(props, state, inputRef);
  let markIcon = isIndeterminate ? /*#__PURE__*/$ad86caa2b7c07dadd21ed122a0b52380$var$React.createElement($ad86caa2b7c07dadd21ed122a0b52380$var$_icons.IDash16, {
    filter: "secondary-icon",
    UNSAFE_className: (0, $ad86caa2b7c07dadd21ed122a0b52380$var$_stylex.default)($ad86caa2b7c07dadd21ed122a0b52380$var$styles.dash)
  }) : /*#__PURE__*/$ad86caa2b7c07dadd21ed122a0b52380$var$React.createElement($ad86caa2b7c07dadd21ed122a0b52380$var$_icons.CheckMarkIcon, {
    size: 18,
    UNSAFE_className: $ad86caa2b7c07dadd21ed122a0b52380$var$_stylex.default.dedupe({
      display: 'inline-block',
      pointerEvents: 'none',
      fill: 'currentColor',
      width: 18,
      height: 18,
      position: 'absolute',
      color: 'var(--always-white)',
      transition: 'opacity 100ms ease-in-out, transform 100ms ease-in-out'
    }, state.isSelected ? {
      opacity: 1
    } : {
      opacity: 0
    })
  });
  return /*#__PURE__*/$ad86caa2b7c07dadd21ed122a0b52380$var$React.createElement("label", (0, $ad86caa2b7c07dadd21ed122a0b52380$var$_extends2.default)({}, styleProps, hoverProps, {
    ref: domRef,
    className: (0, $ad86caa2b7c07dadd21ed122a0b52380$var$_stylex.joinClasses)((0, $ad86caa2b7c07dadd21ed122a0b52380$var$_stylex.default)($ad86caa2b7c07dadd21ed122a0b52380$var$styles.label), styleProps.className)
  }), /*#__PURE__*/$ad86caa2b7c07dadd21ed122a0b52380$var$React.createElement($ad86caa2b7c07dadd21ed122a0b52380$var$_focus.FocusRing, {
    focusClass: "focus-ring",
    autoFocus: autoFocus
  }, /*#__PURE__*/$ad86caa2b7c07dadd21ed122a0b52380$var$React.createElement("input", (0, $ad86caa2b7c07dadd21ed122a0b52380$var$_extends2.default)({}, inputProps, {
    ref: inputRef,
    className: $ad86caa2b7c07dadd21ed122a0b52380$var$_stylex.default.dedupe({
      margin: 0,
      overflow: 'visible',
      boxSizing: 'border-box',
      padding: 0,
      position: 'absolute',
      top: 0,
      height: '100%',
      zIndex: 1,
      cursor: 'pointer',
      opacity: 0,
      width: '100%'
    }, isDisabled ? {
      pointerEvents: 'none'
    } : null)
  }))), /*#__PURE__*/$ad86caa2b7c07dadd21ed122a0b52380$var$React.createElement("span", {
    className: (0, $ad86caa2b7c07dadd21ed122a0b52380$var$_stylex.joinClasses)((0, $ad86caa2b7c07dadd21ed122a0b52380$var$_stylex.default)($ad86caa2b7c07dadd21ed122a0b52380$var$styles.checkbox), $ad86caa2b7c07dadd21ed122a0b52380$var$_stylex.default.dedupe({
      position: 'relative',
      boxSizing: 'border-box',
      flexGrow: 1,
      height: 18,
      width: 18
    }, isDisabled ? {
      opacity: 0.5
    } : null), state.isSelected && (0, $ad86caa2b7c07dadd21ed122a0b52380$var$_stylex.default)($ad86caa2b7c07dadd21ed122a0b52380$var$styles.checkboxChecked))
  }, markIcon, !disabledHoverBackground && /*#__PURE__*/$ad86caa2b7c07dadd21ed122a0b52380$var$React.createElement("div", {
    className: $ad86caa2b7c07dadd21ed122a0b52380$var$_stylex.default.dedupe({
      position: 'absolute',
      top: 0,
      left: 0,
      bottom: 0,
      right: 0,
      pointerEvents: 'none',
      transitionTimingFunction: 'var(--lf-animation-fade-out)',
      transitionDuration: 'var(--lf-duration-extra-extra-short-out)',
      transitionProperty: 'opacity',
      cursor: 'pointer',
      borderRadius: '50%',
      backgroundColor: 'var(--press-overlay)',
      marginLeft: -8,
      marginRight: -8,
      marginTop: -8,
      marginBottom: -8
    }, isHovered ? {
      opacity: 1
    } : {
      opacity: 0
    })
  })), children && /*#__PURE__*/$ad86caa2b7c07dadd21ed122a0b52380$var$React.createElement("span", {
    className: $ad86caa2b7c07dadd21ed122a0b52380$var$_stylex.default.dedupe({
      textAlign: 'start',
      marginLeft: 12
    }, isDisabled ? {
      opacity: 0.5
    } : null)
  }, children));
}
/**
 * Checkboxes allow users to select multiple items from a list of individual items,
 * or to mark one individual item as selected.
 */


let $ad86caa2b7c07dadd21ed122a0b52380$var$_Checkbox = /*#__PURE__*/$ad86caa2b7c07dadd21ed122a0b52380$var$React.forwardRef($ad86caa2b7c07dadd21ed122a0b52380$var$Checkbox);
$ad86caa2b7c07dadd21ed122a0b52380$export$Checkbox = $ad86caa2b7c07dadd21ed122a0b52380$var$_Checkbox;
$ad86caa2b7c07dadd21ed122a0b52380$exports.Checkbox = $ad86caa2b7c07dadd21ed122a0b52380$export$Checkbox;
Object.keys($ad86caa2b7c07dadd21ed122a0b52380$exports).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  Object.defineProperty($a2c394180a52761b9ab5c8ddb88da4b8$exports, key, {
    enumerable: true,
    get: function get() {
      return $ad86caa2b7c07dadd21ed122a0b52380$exports[key];
    }
  });
});
//# sourceMappingURL=module.js.map
